Pie with Image in JavaScript

Using ApexCharts with JavaScript

This Pie with Image example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [128, 92, 156, 64],
  chart: {
    width: 480,
    type: 'pie',
  },
  labels: ['Cityscape', 'Waterfront', 'Street Art', 'Patterns'],
  title: {
    text: 'Photo Library by Scene',
    align: 'center',
  },
  colors: ['#93C3EE', '#E5C6A0', '#669DB5', '#94A74A'],
  fill: {
    type: 'image',
    opacity: 0.9,
    image: {
      src: [
        '../../assets/images/4274635880_809a4b9d0d_z.jpg',
        '../../assets/images/2979121308_59539a3898_z.jpg',
        '../../assets/images/4679113782_ca13e2e6c0_z.jpg',
        '../../assets/images/stripes.jpg',
      ],
      width: 500,
      height: 500,
    },
  },
  stroke: {
    width: 4,
  },
  legend: {
    show: false,
  },
  dataLabels: {
    enabled: true,
    style: {
      colors: ['#111'],
    },
    background: {
      enabled: true,
      foreColor: '#fff',
      borderWidth: 0,
    },
  },
  plotOptions: {
    pie: {
      dataLabels: {
        external: {
          show: true,
        },
      },
    },
  },
  responsive: [
    {
      breakpoint: 480,
      options: {
        chart: {
          width: 320,
        },
      },
    },
  ],
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Pie with Image in React

Using ApexCharts with React

This Pie with Image example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [128, 92, 156, 64],
    options: {
      chart: {
        width: 480,
        type: 'pie',
      },
      labels: ['Cityscape', 'Waterfront', 'Street Art', 'Patterns'],
      title: {
        text: 'Photo Library by Scene',
        align: 'center',
      },
      colors: ['#93C3EE', '#E5C6A0', '#669DB5', '#94A74A'],
      fill: {
        type: 'image',
        opacity: 0.9,
        image: {
          src: [
            '../../assets/images/4274635880_809a4b9d0d_z.jpg',
            '../../assets/images/2979121308_59539a3898_z.jpg',
            '../../assets/images/4679113782_ca13e2e6c0_z.jpg',
            '../../assets/images/stripes.jpg',
          ],
          width: 500,
          height: 500,
        },
      },
      stroke: {
        width: 4,
      },
      legend: {
        show: false,
      },
      dataLabels: {
        enabled: true,
        style: {
          colors: ['#111'],
        },
        background: {
          enabled: true,
          foreColor: '#fff',
          borderWidth: 0,
        },
      },
      plotOptions: {
        pie: {
          dataLabels: {
            external: {
              show: true,
            },
          },
        },
      },
      responsive: [
        {
          breakpoint: 480,
          options: {
            chart: {
              width: 320,
            },
          },
        },
      ],
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="pie"
          width={480}
        />
      </div>
    </div>
  )
}

export default ApexChart

Pie with Image in Angular

Using ApexCharts with Angular

This Pie with Image example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [128, 92, 156, 64],
          chart: {
            width: 480,
            type: 'pie',
          },
          labels: ['Cityscape', 'Waterfront', 'Street Art', 'Patterns'],
          title: {
            text: 'Photo Library by Scene',
            align: 'center',
          },
          colors: ['#93C3EE', '#E5C6A0', '#669DB5', '#94A74A'],
          fill: {
            type: 'image',
            opacity: 0.9,
            image: {
              src: [
                'https://apexcharts.com/samples/assets/images/4274635880_809a4b9d0d_z.jpg',
                'https://apexcharts.com/samples/assets/images/2979121308_59539a3898_z.jpg',
                'https://apexcharts.com/samples/assets/images/4679113782_ca13e2e6c0_z.jpg',
                'https://apexcharts.com/samples/assets/images/stripes.jpg',
              ],
              width: 500,
              height: 500,
            },
          },
          stroke: {
            width: 4,
          },
          legend: {
            show: false,
          },
          dataLabels: {
            enabled: true,
            style: {
              colors: ['#111'],
            },
            background: {
              enabled: true,
              foreColor: '#fff',
              borderWidth: 0,
            },
          },
          plotOptions: {
            pie: {
              dataLabels: {
                external: {
                  show: true,
                },
              },
            },
          },
          responsive: [
            {
              breakpoint: 480,
              options: {
                chart: {
                  width: 320,
                },
              },
            },
          ],
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Pie with Image in Vue

Using ApexCharts with Vue

This Pie with Image example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="pie"
        width="480"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [128, 92, 156, 64],
      chartOptions: {
        chart: {
          width: 480,
          type: 'pie',
        },
        labels: ['Cityscape', 'Waterfront', 'Street Art', 'Patterns'],
        title: {
          text: 'Photo Library by Scene',
          align: 'center',
        },
        colors: ['#93C3EE', '#E5C6A0', '#669DB5', '#94A74A'],
        fill: {
          type: 'image',
          opacity: 0.9,
          image: {
            src: [
              '../../assets/images/4274635880_809a4b9d0d_z.jpg',
              '../../assets/images/2979121308_59539a3898_z.jpg',
              '../../assets/images/4679113782_ca13e2e6c0_z.jpg',
              '../../assets/images/stripes.jpg',
            ],
            width: 500,
            height: 500,
          },
        },
        stroke: {
          width: 4,
        },
        legend: {
          show: false,
        },
        dataLabels: {
          enabled: true,
          style: {
            colors: ['#111'],
          },
          background: {
            enabled: true,
            foreColor: '#fff',
            borderWidth: 0,
          },
        },
        plotOptions: {
          pie: {
            dataLabels: {
              external: {
                show: true,
              },
            },
          },
        },
        responsive: [
          {
            breakpoint: 480,
            options: {
              chart: {
                width: 320,
              },
            },
          },
        ],
      },
    }
  },
}
</script>

<style>
#chart {
  padding: 0;
  max-width: 480px;
  margin: 35px auto;
}
</style>